'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _uuid = require('../utils/uuid');

var _uuid2 = _interopRequireDefault(_uuid);

var _specialAssign = require('../utils/special-assign');

var _specialAssign2 = _interopRequireDefault(_specialAssign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var checkedProps = {
  tag: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.bool]),
  children: _react.PropTypes.node
};

var ComboBox = function (_Component) {
  _inherits(ComboBox, _Component);

  function ComboBox() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ComboBox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ComboBox.__proto__ || Object.getPrototypeOf(ComboBox)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      inputNode: null,
      activeDescendant: null
    }, _this._id = (0, _uuid2.default)(), _this._setInputNode = function (node) {
      _this.setState({ inputNode: node });
    }, _this._setActiveDescendant = function (item) {
      _this.setState({ activeDescendant: item });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ComboBox, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        comboBox: {
          uuid: this._id,
          setInputNode: this._setInputNode,
          inputNode: this.state.inputNode,
          setActiveDescendant: this._setActiveDescendant,
          activeDescendant: this.state.activeDescendant
        }
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var tag = _props.tag;

      var props = _objectWithoutProperties(_props, ['tag']);

      return tag ? (0, _react.createElement)(tag, props) : props.children;
    }
  }]);

  return ComboBox;
}(_react.Component);

ComboBox.childContextTypes = {
  comboBox: _react.PropTypes.object
};
ComboBox.propTypes = checkedProps;
ComboBox.defaultProps = {
  tag: 'div'
};
exports.default = ComboBox;
module.exports = exports['default'];